var tabClicking = {
  version: '0.6.4',
  tcPrefs: null,
  toBeClonedBrowser: null,
  selectedTab: null,
  openedBrowser: null,
  openedWindow: null,
  clonedHistory: null,
  scrollPosX: 0,
  scrollPosY: 0,
  zoomFactor: 100,

  tablib: {
    PREFS: ['tablib.tabs_open_relative', 'extensions.tabmix.openTabNext', 'extensions.minit.open_tab'],
    tablibPref: null
  },

  funcs: {
    onTabClick: null,
    onTabBarDblClick: null
  },

  prefs: {
    action: 0,
    selectTab: true,
    tablib: false
  },

    /* replace tab click functions with new functions on browser load */
  onLoad: function()
  {
    tabClicking.tcPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(null);
    tabClicking.funcs.onTabClick = gBrowser.onTabClick;
    tabClicking.funcs.onTabBarDblClick = gBrowser.onTabBarDblClick;
    gBrowser.onTabClick = tabClicking.onTabClick;
    gBrowser.mTabContainer.setAttribute('ondblclick', 'tabClicking.onTabBarDblClick(event);');
    if (window.tablib)
    {
      tablib.init();
      for (var i=0; i<3; i++) {
        if (gBrowser.addTab.toString().indexOf(tabClicking.tablib.PREFS[i]) != -1)
          tabClicking.tablib.tablibPref = tabClicking.tablib.PREFS[i];
      }
    }
  },

  onTabClick: function(evt) {
    var eCtrlKey = (((evt.ctrlKey)||(evt.metaKey)) && (!evt.altKey) && (!evt.shiftKey));
    var eAltKey = ((!(evt.ctrlKey)||(evt.metaKey)) && (evt.altKey) && (!evt.shiftKey));
    var eShiftKey = ((!(evt.ctrlKey)||(evt.metaKey)) && (!evt.altKey) && (evt.shiftKey));

    // don't do anything when the tabs close buttun is clicked
    // or close buttons added by other extensions (eg. Tab Mix, Tab X)
    if (evt.originalTarget.getAttribute('class').indexOf('close') !=  -1)
      return;

    if ((tabClicking.tcPrefs.getBoolPref("middlemouse.contentLoadURL")) && (evt.button == 1))
      return;

    var eTabClicked = false, evtTarget = evt.originalTarget;
    while (evtTarget.localName != 'tabs') {
      eTabClicked = (evtTarget.localName == 'tab')
      if (eTabClicked)
        break;
      evtTarget = evtTarget.parentNode;
    }

    // load preferences for tab click
    var actionNum = tabClicking.tcPrefs.getCharPref("extensions.tabclicking.action");
    var selectTabNum = tabClicking.tcPrefs.getCharPref("extensions.tabclicking.select_new_tab");

    // clicked on a tab
    if (eTabClicked)
    {
      // asign selected tab to variable
      var selectedTab = evtTarget;
      // middle click on tab
      if (evt.button == 1)
      {
        tabClicking.setTCPrefs(2, actionNum, selectTabNum);
        tabClicking.switchCase(selectedTab, evt);
      }
      // ctrl click on tab
      else if ((evt.button == 0) && (eCtrlKey))
      {
        tabClicking.setTCPrefs(4, actionNum, selectTabNum);
        tabClicking.switchCase(selectedTab, evt);
      }
      // alt click on tab
      else if ((evt.button == 0) && (eAltKey))
      {
        tabClicking.setTCPrefs(6, actionNum, selectTabNum);
        tabClicking.switchCase(selectedTab, evt);
      }
      // shift click on tab
      else if ((evt.button == 0) && (eShiftKey))
      {
        tabClicking.setTCPrefs(8, actionNum, selectTabNum);
        tabClicking.switchCase(selectedTab, evt);
      }
    }

    // if not clicked on a tab, but the tab bar
    else if (!eTabClicked)
    {
      // asign current open tab to variable
      var theTab = gBrowser.mCurrentTab;
      // middle click on tabbar
      if (evt.button == 1)
      {
        tabClicking.setTCPrefs(3, actionNum, selectTabNum);
        tabClicking.switchCase(theTab, evt);
      }
      // ctrl click on tabbar
      else if ((evt.button == 0) && (eCtrlKey))
      {
        tabClicking.setTCPrefs(5, actionNum, selectTabNum);
        tabClicking.switchCase(theTab, evt);
      }
      // alt click on tabbar
      else if ((evt.button == 0) && (eAltKey))
      {
        tabClicking.setTCPrefs(7, actionNum, selectTabNum);
        tabClicking.switchCase(theTab, evt);
      }
      // shift click on tabbar
      else if ((evt.button == 0) && (eShiftKey))
      {
        tabClicking.setTCPrefs(9, actionNum, selectTabNum);
        tabClicking.switchCase(theTab, evt);
      }
    }
  },

    /* double click function */
  onTabBarDblClick: function(aEvent) {
    var eTabClicked = false, evtTarget = aEvent.originalTarget;
    while (evtTarget.localName != 'tabs') {
      eTabClicked = (evtTarget.localName == 'tab')
      if (eTabClicked)
        break;
      evtTarget = evtTarget.parentNode;
    }
    var eNoModifierKey = ((!aEvent.shiftKey) && (!aEvent.altKey) && ((!aEvent.ctrlKey) || (!aEvent.metaKey)));

    // load preferences for double clicking
    var actionNum = tabClicking.tcPrefs.getCharPref("extensions.tabclicking.action");
    var selectTabNum = tabClicking.tcPrefs.getCharPref("extensions.tabclicking.select_new_tab");

    // check for double-left-clicking on the tabbar, not using alt, ctrl or shift key
    if ((!eTabClicked) && (aEvent.button == 0) && eNoModifierKey) {
      // asign currently open tab to variable
      var theTab = gBrowser.mCurrentTab;
      tabClicking.setTCPrefs(1, actionNum, selectTabNum);
      tabClicking.switchCase(theTab, aEvent);
    }
    // check for double-left-clicking on a tab, not using alt, ctrl or shift key
    else if ((eTabClicked) && (aEvent.button == 0) && eNoModifierKey) {
      // assign tab on which is double clicked to variable
      var dblclickedTab = evtTarget;
      tabClicking.setTCPrefs(0, actionNum, selectTabNum);
      tabClicking.switchCase(dblclickedTab, aEvent);
    }
  },

  setTCPrefs: function(aNumber, aString1, aString2) {
    this.prefs.action = parseInt(aString1.charAt(aNumber), 20);
    var newTabVal = parseInt(aString2.charAt(aNumber))
    this.prefs.selectTab = Boolean(newTabVal%2);
    this.prefs.tablib = ((newTabVal > 1) && (gBrowser.moveTabTo != undefined));
  },

  switchCase: function(aTab, aEvent) {
    switch (tabClicking.prefs.action) {

      // add new tab
      case 1:
        var newTab, currentTab = gBrowser.mCurrentTab;

        // compatibility with TabBrowser Preferences (https://addons.mozilla.org/extensions/moreinfo.php?id=158)
        if (window.TBP_BrowserOpenTabClick)
        {
          newTab = TBP_BrowserOpenTabClick(aEvent);
          var TBPloadhome = false, TBPbackground = false;
          try {
            if (tabClicking.tcPrefs.getPrefType("extensions.tabprefs.loadHome"))
              TBPloadhome = tabClicking.tcPrefs.getBoolPref("extensions.tabprefs.loadHome");
            else if (tabClicking.tcPrefs.getPrefType("extensions.tabprefs.loadNewInBackground"))
              TBPbackground = tabClicking.tcPrefs.getBoolPref("extensions.tabprefs.loadNewInBackground");
          }
          catch(e) {}
          if (!tabClicking.prefs.selectTab && !TBPloadhome)
            gBrowser.selectedTab = aTab;
          else if (tabClicking.prefs.selectTab && TBPbackground)
            gBrowser.selectedTab = newTab;
        }

        // compatibility with New Tab Homepage (http://www.cusser.net/extensions/tabhomepage/)
        else if (window.newtabhomepage) {
          newTab = newtabhomepage.opentab(aEvent);
          if (!tabClicking.prefs.selectTab)
            gBrowser.selectedTab = aTab;
          else
            gBrowser.selectedTab = newTab;
        }

        else {
          newTab = gBrowser.addTab();
          if (tabClicking.prefs.selectTab) {
            gBrowser.selectedTab = newTab;
            tabClicking.selectURLBar();
          }
        }

        if (tabClicking.prefs.tablib)
          gBrowser.moveTabTo(newTab, currentTab._tPos+1);
        // don't place the new tab next to the current if the user doesn't want that
        else if (gBrowser.moveTabTo && tabClicking.tablib.tablibPref) {
          var currentTabLibPref = tabClicking.tcPrefs.getBoolPref(tabClicking.tablib.tablibPref);
          if (currentTabLibPref)
            gBrowser.moveTabTo(newTab, gBrowser.mTabContainer.childNodes.length-1);
        }
        break;

      // reload tab
      case 2:
        gBrowser.getBrowserForTab(aTab).reload();
        if (this.prefs.selectTab)
          gBrowser.selectedTab = aTab;
        break;

      // reload all tabs
      case 3:
        gBrowser.reloadAllTabs(aTab);
        break;

      // close tab
      case 4:
        gBrowser.removeTab(aTab);
        aEvent.stopPropagation();
        break;

      // close other tabs
      case 5:
        gBrowser.removeAllTabsBut(aTab);
        break;

      // Close All Tabs
      case 6:
        tabClicking.closeAllTabs();
        break;

      // duplicate tab
      case 7:
        tabClicking.toBeClonedBrowser = gBrowser.getBrowserForTab(aTab);
        tabClicking.selectedTab = aTab
        tabClicking.duplicateInTab();
        break;

      // duplicate tab to new window
      case 8:
        tabClicking.toBeClonedBrowser = gBrowser.getBrowserForTab(aTab);
        tabClicking.duplicateInWindow();
        break;

      // Undo Remove Tab (UndoCloseTab extension)
      case 9:
        if (gBrowser.undoRemoveTab)
          gBrowser.undoRemoveTab();
        break;

      // select tab for merging (Duplicate Tab 0.3 and newer)
      case 10:
        if (duplicateTab && duplicateTab.selectBrowser) {
          duplicateTab.selectedTab = aTab;
          duplicateTab.selectBrowser();
        }
        break;

      // Reopen Last Closed Tab (Click2Tab extension)
      case 11:
        if (TabbrowserClick2Tab && TabbrowserClick2Tab.undoLastClosedTab)
            TabbrowserClick2Tab.undoLastClosedTab();
        break;

      // View Tab in IE
      case 12:
        if (IeView && IeView.ieViewLaunch) {
          var href = gBrowser.getBrowserForTab(aTab).currentURI.spec;
          IeView.ieViewLaunch("Internet Explorer.lnk", href);
        }
        break;

      // SnapBack Tab (SessionSaver extension)
      case 13:
        if (SessionSaver && SessionSaver.snapBackTab)
            SessionSaver.snapBackTab(SessionSaver.snapback_noFX, SessionSaver.snapback_willFocus);
        break;

      // Bookmark This Tab...
      case 14:
        var browserSpecs = gBrowser.getBrowserForTab(aTab).webNavigation;
        if (BookmarksUtils.addBookmarkForBrowser)
          BookmarksUtils.addBookmarkForBrowser(browserSpecs);
        else if (addBookmarkForBrowser)
          addBookmarkForBrowser(browserSpecs);
        break;

      // Bookmark All Tabs... (only in firefox 1.5 and up and Seamonkey / Mozilla Suite)
      case 15:
        if (document.getElementById('Browser:BookmarkAllTabs'))
          addBookmarkForTabBrowser(gBrowser, true);
        else if (addGroupmarkAs) // Seamonkey / Mozilla Suite code
          addGroupmarkAs();
        break;

      // Do Nothing
      default:
        break;
    }
  },

  closeAllTabs: function() {
    var tabs = gBrowser.mTabContainer.childNodes
    var l = tabs.length;
    while (l > 1) {
      l--;
      gBrowser.removeTab(tabs[l]);
    }
    if (l == 1) {
      var theBrowser = gBrowser.mCurrentBrowser;
      theBrowser.loadURI('about:blank');
      var sHistory = theBrowser.webNavigation.sessionHistory;
      var sHistoryLength = sHistory.count;
      sHistory.PurgeHistory(sHistoryLength);
      tabClicking.selectURLBar();
    }
  },

  selectURLBar: function() {
    if (!gURLBar) gURLBar = document.getElementById('urlbar');
    if (gURLBar) setTimeout(function() { gURLBar.focus(); }, 0);
  },

  // duplicate tab funcion
  duplicateInTab: function() {
    delete this.clonedHistory;
    this.clonedHistory = this.copyTabHistory(this.toBeClonedBrowser.webNavigation.sessionHistory);
    this.scrollPosX = this.toBeClonedBrowser.contentWindow.scrollX;
    this.scrollPosY = this.toBeClonedBrowser.contentWindow.scrollY;
    this.zoomFactor = this.toBeClonedBrowser.markupDocumentViewer.textZoom;

    // Open new tab
    var newTab = gBrowser.addTab();

    // give focus to new tab as desired by user
    if (tabClicking.prefs.selectTab)
      gBrowser.selectedTab = newTab;

    // place the tab next to the current if desired
    if (tabClicking.prefs.tablib) {
      if (newTab._tPos > tabClicking.selectedTab._tPos)
        gBrowser.moveTabTo(newTab, tabClicking.selectedTab._tPos+1);
      else if (newTab._tPos < tabClicking.selectedTab._tPos)
        gBrowser.moveTabTo(newTab, tabClicking.selectedTab._tPos);
    }
    // don't place the tab next to the current if the user doesn't want that, but tablib is set to do so
    else if (gBrowser.moveTabTo && tabClicking.tablib.tablibPref) {
      var currentTabLibPref = tabClicking.tcPrefs.getBoolPref(tabClicking.tablib.tablibPref);
      if (currentTabLibPref)
        gBrowser.moveTabTo(newTab, gBrowser.mTabContainer.childNodes.length-1);
    }
    this.openedBrowser = gBrowser.getBrowserForTab(newTab);

    // Clone history to new tab
    this.cloneTabHistory(this.openedBrowser.webNavigation, this.clonedHistory);

    // Restore scroll position and zoom factor
    window.setTimeout(function() {tabClicking.openedBrowser.contentWindow.scrollTo(tabClicking.scrollPosX, tabClicking.scrollPosY);}, 0);
    this.openedBrowser.markupDocumentViewer.textZoom = this.zoomFactor;

    // Select URL bar
    if (gURLBar) window.setTimeout('gURLBar.select();', 100);
  },

  duplicateInWindow: function()
  {
    // Copy current history and scroll position to vars
    delete this.clonedHistory;
    this.clonedHistory = this.copyTabHistory(this.toBeClonedBrowser.webNavigation.sessionHistory);
    this.scrollPosX = this.toBeClonedBrowser.contentWindow.scrollX;
    this.scrollPosY = this.toBeClonedBrowser.contentWindow.scrollY;
    this.zoomFactor = this.toBeClonedBrowser.markupDocumentViewer.textZoom;

    // Open new window
    var chromeURL = tabClicking.tcPrefs.getCharPref("browser.chromeURL");
    this.openedWindow = window.openDialog(chromeURL, '_blank', 'chrome,all,dialog=no');

    // Wait until session history is created in new window
    this.openedWindow.addEventListener('load', function() {tabClicking.waitForSessionHistory(10);}, false);
  },

  waitForSessionHistory: function(attempts)
  {
    // Test if sessionHistory exists yet
    var webNav = this.openedWindow.document.getElementById('content').webNavigation;
    try
    {
      webNav.sessionHistory;
    }
    catch (err)
    {
      // Error occurred, try again later
      if (attempts) window.setTimeout('tabClicking.waitForSessionHistory(' + --attempts + ')', 100);
      return;
    }
    if ((webNav.sessionHistory == null) && attempts)
    {
      window.setTimeout('tabClicking.waitForSessionHistory(' + --attempts + ')', 100);
      return;
    }

    // Clone history to new window
    this.cloneTabHistory(webNav, tabClicking.clonedHistory);

    // Restore scroll position and zoom factor if enabled
    this.openedBrowser = this.openedWindow.document.getElementById('content').mCurrentBrowser;
    window.setTimeout(function() {tabClicking.openedBrowser.contentWindow.scrollTo(tabClicking.scrollPosX, tabClicking.scrollPosY);}, 0);
    this.openedBrowser.markupDocumentViewer.textZoom = this.zoomFactor;
  },

  copyTabHistory: function(originalHistory)
  {
    // Copy passed in history into an array and return it
    var copiedHistory = new Array();
    for (var i = 0; i < originalHistory.count; i++)
    {
      copiedHistory.push(originalHistory.getEntryAtIndex(i, false));
    }
    copiedHistory.index = originalHistory.index;
    return copiedHistory;
  },

  cloneHistoryEntry: function(aEntry) {
    if (!aEntry)
      return null;
    aEntry = aEntry.QueryInterface(Components.interfaces.nsISHContainer);
    var newEntry = aEntry.clone();
    newEntry = newEntry.QueryInterface(Components.interfaces.nsISHContainer);
    newEntry.loadType = Math.floor(aEntry.loadType);
    if (aEntry.childCount) {
      for (var j = 0; j < aEntry.childCount; j++) {
        var childEntry = tabClicking.cloneHistoryEntry(aEntry.GetChildAt(j));
        if (childEntry)
          newEntry.AddChild(childEntry, j);
      }
    }
    return newEntry;
  },

  cloneTabHistory: function(webNav, originalHistory)
  {
    // Clone history from var
    var newHistory = webNav.sessionHistory;
    newHistory.QueryInterface(Components.interfaces.nsISHistoryInternal);
    if (newHistory.count > 0)
      newHistory.PurgeHistory(newHistory.count);
    for (var i = 0; i < originalHistory.length; i++)
    {
      var entry = originalHistory[i].QueryInterface(Components.interfaces.nsISHEntry);
      var newEntry = tabClicking.cloneHistoryEntry(entry);
      if (newEntry)
        newHistory.addEntry(newEntry, true);
    }

    // Goto current history location
    if (originalHistory.length > 0 && originalHistory.index >= 0)
    {
      try
      {
        webNav.gotoIndex(originalHistory.index);
      }
      catch(e) {
        window.setTimeout('tabClicking.openedBrowser.webNavigation.gotoIndex('+originalHistory.index+')', 0);
      }
    }
  }
}

// load onLoad function on browser load
window.addEventListener("load",tabClicking.onLoad,false);
